//+------------------------------------------------------------------+
//|                                        StatisticCarryTrading.mq4 |
//|                                Copyright  2012, Ruslan V. Lunev |
//|                              http://www.mql5.com/ru/articles/491 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Ruslan V. Lunev"
#property link      "http://www.mql5.com/ru/articles/491"

extern int p = 100.0;
extern string secondpair = "AUDUSD";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  test();
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   return(0);
}
//+------------------------------------------------------------------+

void test() {
   int i = 0;
   
   double pp = p;
   
   double s1 = 0;
   double s2 = 0;
   double s3 = 0;
   double s4 = iOpen(secondpair, PERIOD_D1, 0) - iOpen(secondpair, PERIOD_D1, p);
   double s5 = Open[0] - Open[p];
   
   double averagex = s4 / pp;
   double averagey = s5 / pp;

   for (i = 0; i < p; i++) {
      double x0 = iOpen(secondpair, PERIOD_D1, i) - iOpen(secondpair, PERIOD_D1, i + 1);
      double y0 = Open[i] - Open[i + 1];
      double x1 = x0 - averagex;
      double y1 = y0 - averagey;
      s1 = s1 + x1 * x1;
      s2 = s2 + y1 * y1;
      s3 = s3 + x1 * y1;
   }
   
   double r = s3 / MathSqrt(s1 * s2);
   
   
   double a = signum(r) * MarketInfo(Symbol(), MODE_LOTSIZE) * MathSqrt(s2) / (MathSqrt(s1) * MarketInfo(secondpair, MODE_LOTSIZE));
   double b = averagey - averagex * a;
   
   if (b > 0) {
      Print(Symbol() + " = ", a, " * " + secondpair + " + ", b);
   } else {
      Print(Symbol() + " = ", a, " * " + secondpair + " - ", MathAbs(b));
   }
   
   a = -a * signum(b);
   
         
   string recomendation = "Buy " + Symbol();


   if (b < 0) {
      recomendation = "Sell " + Symbol();
      if (MarketInfo(Symbol(), MODE_SWAPSHORT) < 0.0) {
         recomendation = "Short positions swap in " + Symbol() + " is negative";
         MessageBox(recomendation, "Not recommended", 1);
         return(0);
      }  
   } else {
      if (MarketInfo(Symbol(), MODE_SWAPLONG) < 0.0) {
         recomendation = "Long positions swap in " + Symbol() + " is negative";
         MessageBox(recomendation, "Not recommended", 1);
         return(0);
      }  
   }
      
   
   if (a < 0) {
      recomendation = recomendation + "\r\nSell " + a + " " + secondpair;
      if (MarketInfo(secondpair, MODE_SWAPSHORT) < 0.0) {
         recomendation = "Short positions swap in " + secondpair + " is negative";
         MessageBox(recomendation, "Not recommended", 1);
         return(0);
      }  
   } else {
      recomendation = recomendation + "\r\nBuy " + a + " " + secondpair;
      if (MarketInfo(secondpair, MODE_SWAPLONG) < 0.0) {
         recomendation = "Long positions swap in " + secondpair + " is negative";
         MessageBox(recomendation, "Not recommended", 1);
         return(0);
      }  
   } 
   
   double profit = MathAbs(b) / Point;
   
   if ((Digits == 5) || (Digits == 3)) {
      profit = profit / 10;
   }
   
   recomendation = recomendation + "\r\nCorrelation coefficient: " + r;
   recomendation = recomendation + "\r\nAverage daily profit: " + profit + " points";
   
   
   MessageBox(recomendation, "Recommendation", 1);
   
   return(0);
}

double signum(double x) {
   if (x < 0.0) {
      return(-1.0);
   }
   if (x == 0.0) {
      return(0);
   }
   return(1.0);
}